from mesh import *
from vector import *
from mesh_topology import *

import math

#octahedron
def octahedron():
    """returns an octahedral mesh.  For testing"""
    vertices = []
    vertices.append(Vertex([1,0,0]))
    vertices.append(Vertex([-1,0,0]))
    vertices.append(Vertex([0,1,0]))
    vertices.append(Vertex([0,-1,0]))
    vertices.append(Vertex([0,0,1]))
    vertices.append(Vertex([0,0,-1]))
    edges=[]
    edges.append(Edge(vertices[0], vertices[2]))
    edges.append(Edge(vertices[0], vertices[3]))
    edges.append(Edge(vertices[0], vertices[4]))
    edges.append(Edge(vertices[0], vertices[5]))
    edges.append(Edge(vertices[1], vertices[2]))
    edges.append(Edge(vertices[1], vertices[3]))
    edges.append(Edge(vertices[1], vertices[4]))
    edges.append(Edge(vertices[1], vertices[5]))
    edges.append(Edge(vertices[2], vertices[4]))
    edges.append(Edge(vertices[4], vertices[3]))
    edges.append(Edge(vertices[3], vertices[5]))
    edges.append(Edge(vertices[5], vertices[2]))
    faces=[]
    faces.append(Face(edges[0], edges[8], edges[2]))
    faces.append(Face(edges[2], edges[9], edges[1]))
    faces.append(Face(edges[1], edges[10], edges[3]))
    faces.append(Face(edges[3], edges[11], edges[0]))
    faces.append(Face(edges[6], edges[8], edges[4]))
    faces.append(Face(edges[5], edges[9], edges[6]))
    faces.append(Face(edges[7], edges[10], edges[5]))
    faces.append(Face(edges[4], edges[11], edges[7]))

    return Mesh(vertices, edges, faces)

def disc():
    """returns a bubble on a circular wire"""
    angles = [2*math.pi * i/20 for i in range(20)]
    wire_points = [Vector([math.cos(t), math.sin(t), 0]) for t in angles]
    wire = Wire(wire_points)
    return wire.seed_one_point(Vector([0,0,1]))

