'''
Created on Mar 29, 2011

@author: ari
'''

from vector import *

class Stepper:
    '''
    classdocs
    '''

    def __init__(self,bubble):
        self.bubble = bubble
        self.t_step = .01
        self.count =0

    def step(self, verbose = True):
        if verbose:
            print "STEP =", self.count
            print "number of vertices:", len(self.bubble.mesh.vertices)
            print "number of faces:", len(self.bubble.mesh.faces)
            print "number of edges:", len(self.bubble.mesh.edges)
        
        #print 'remeshing'
        #self.bubble.mesh.remesh()

        da = 0.0001
        print 'minimizing dirichle energy'
        #self.dirichlet_minimizing_step(1)
        res = self.dirichlet_to_d_area(da) 
        print res, "steps to get to delta area =", da

        print 'collapsing small faces: ',
        collapsed_face_count = self.collapse_small_faces()
        print collapsed_face_count

        print 'breaking sharp edges:'
        split_edge_count = self.bubble.mesh.break_sharp_edges()
        print "broke: ", split_edge_count

        print 'collapsing small faces: ',
        collapsed_face_count = self.collapse_small_faces()
        print collapsed_face_count

        self.count +=1

        print 'Finished Step'
        
    def normal_mean_curvature_step(self):
        moves = []
        for v in self.bubble.mesh.vertices:
            is_on_wire = False
            for w in self.bubble.wires:
                if v in w.vertices: 
                    is_on_wire = True
                    break
            if not is_on_wire:
                normal, curvature = v.mean_curvature()
                moves.append(self.t_step * normal * curvature)
            else:
                moves.append(Vector([0,0,0]))
        for i in range(len(self.bubble.mesh.vertices)):
            v = self.bubble.mesh.vertices[i]
            v.pos += moves[i]

    def dirichlet_minimizing_step(self, step_size):
        new_verts = []
        for v in self.bubble.mesh.vertices:        
            is_on_wire = False
            for w in self.bubble.wires:
                if v in w.vertices: 
                    is_on_wire = True
                    break
            if not is_on_wire:
                new_pos = v.pos + step_size*(v.min_dirichlet_energy() - v.pos)
                new_verts.append(new_pos)
            else:
                new_verts.append(v.pos)

        for i in range(len(self.bubble.mesh.vertices)):
            v = self.bubble.mesh.vertices[i]
            v.pos = new_verts[i]

    def collapse_small_faces(self):
        count = 0
        for f in self.bubble.mesh.faces:
            if f.area()<.00000001:
                is_on_wire=False
                for w in self.bubble.wires:
                    for v in f.vertices:
                        if v in w.vertices: 
                            is_on_wire = True
                            break
                if not is_on_wire:
                    count += 1
                    self.bubble.mesh.collapse_face(f)        
        return count

    def dirichlet_to_d_area(self, da):
        keep_minimizing = True        
        count = 0
        while keep_minimizing: 
            if count>0:
                prev_area = current_area
            self.dirichlet_minimizing_step(1)
            current_area = self.bubble.mesh.area()
            print 'bubble area:', current_area
            if count > 1:
                #d_area should always be negative
                d_area = current_area - prev_area   
                
                if d_area > -da:
                    keep_minimizing = False
            count +=1
        return count



